//  Copyright (c) 2012 Dennco Project
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

//
//  Created by tkawata on 1/7/2012.
//

#ifndef dennco_DNUtils_h
#define dennco_DNUtils_h

#include <string>
#include "TKLock.h"

void trimString(std::string& str);
std::string upperString( const std::string &src );

std::string getFQNString(const char *location, const char *name);
std::string getJSEscapeString(const char *cstring);
std::string parseCellCodeForScriptEngine(std::string jname, std::string cellCode);

void dnNotifyError(std::string title, std::string message);
void dnNotifyWarning(std::string title, std::string message);

class DNLocker
{
public:
    DNLocker(TKLock *lock) : mLock(lock) {mLock->lock();}
    ~DNLocker() { mLock->unlock();}
private:
    TKLock *mLock;
};

#endif
