//  Copyright (c) 2012 Dennco Project
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

//
//  Created by tkawata on Sep-30, 2012.
//
#include "dcvccellcode.h"

#include "dcvcomponent.h"
#include "dccellcode.h"
#include "dccontainer.h"

DCVCCellCode::DCVCCellCode(DCCellCode *owner, DCVCPage *page) : DCVPageComponent(page), d_owner(owner)
{
}

void DCVCCellCode::changePageBelonging(DCVCPage *page)
{
    if (getPageBelonging() != page)
    {
        if (page)
        {
            page->registerCellCodeClass(this);
        }
        else
        {
            getPageBelonging()->unregisterCellCodeClass(this);
        }
    }

    DCContainer *container = d_owner->getContainer();
    if (container)
    {
        if (getPageBelonging())
        {
            container->moveCellCodeClass(getOwnerCellCodeClass(), page->getLocationPath());
        }
        else
        {
            //TODO
        }
    }
}
